"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
function* splitIterable(iterable, sep) {
    let store = Array();
    for (const item of iterable) {
        if (sep(item)) {
            yield store;
            store = [];
        }
        else {
            store.push(item);
        }
    }
    yield store;
}
exports.splitIterable = splitIterable;
function splitAsyncIterable(iterable, sep) {
    return tslib_1.__asyncGenerator(this, arguments, function* splitAsyncIterable_1() {
        var e_1, _a;
        let store = Array();
        try {
            for (var iterable_1 = tslib_1.__asyncValues(iterable), iterable_1_1; iterable_1_1 = yield tslib_1.__await(iterable_1.next()), !iterable_1_1.done;) {
                const item = iterable_1_1.value;
                if (yield tslib_1.__await(sep(item))) {
                    yield yield tslib_1.__await(store);
                    store = [];
                }
                else {
                    store.push(item);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (iterable_1_1 && !iterable_1_1.done && (_a = iterable_1.return)) yield tslib_1.__await(_a.call(iterable_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
        yield yield tslib_1.__await(store);
    });
}
exports.splitAsyncIterable = splitAsyncIterable;
//# sourceMappingURL=index.js.map